Changelog
=========

1.5.1 (November 1, 2023)
--------------------------

DEPLOYMENT NOTES
^^^^^^^^^^^^^^^^
Prometheus metrics are now published on ``/metrics`` (the default for Prometheus and in our other products). By default this is turned *off* and can be turned on by setting ``ZONECONTROL_METRICS_ENABLED`` to ``True`` in ``settings.py``. Accessing the metrics requires no authentication.
The number of zones metric (``zonecontrol_zones``) is only exported when the caching of zones is enabled (``ZONECONTROL_CACHE_ZONES = True``).

BUG FIXES
^^^^^^^^^
- Make sure users with RRSet limits cannot export zones `!296 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/296>`__ `!297 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/297>`__
- Fix issue with ``Native`` staying the default in the background when removing it from ``ZONECONTROL_ALLOW_ZONE_KINDS`` `!295 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/295>`__

NEW FEATURES
^^^^^^^^^^^^
- Publish Prometheus metrics on ``/metrics`` `!298 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/298>`__

1.5.0 (October 2, 2023)
--------------------------

DEPLOYMENT NOTES
^^^^^^^^^^^^^^^^
Zone names are now normalized when parsing them from the API or UI. In the past Curl scripts used for migrations at customers used zones without a dot at the end. These will still work but realize the zone will *always* get a dot at the end inside ZoneControl now.

Database tables for zone audit logs and zone history at customers may still have entries without a dot at the end. This release comes with a migration to append a dot to zones without a dot (at the end) in the audit log and zone history tables. **Please test this migration in a non-production environment first!**

The HTTP status response code for a successful ``POST`` call to ``api/v1/servers/«SERVER_ID»/zones`` has been changed from ``200`` to ``201``. This is the API call for creating a zone.

This might affect software and scripts that check for an exact 2xx status response instead of checking for a success response code.

It is now possible to override the Gunicorn config with an ``/etc/zonecontrol/gunicorn_overrides.py`` file. This procedure is similar to how it is done in the Platform Filter and is already implemented in the ZoneControl Ansible role.

BUG FIXES
^^^^^^^^^
- Fix silent failure when adding a zone with non-canonical nameservers (no dot at the end) `!294 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/294>`__
- Normalize zone names when receiving them from the API or UI `!286 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/286>`__
- Make background opaque on template dropdown UI element `!285 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/285>`__
- Check for AnonymousUser in more places, preventing stack traces `!284 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/284>`__
- Make ZoneControl API status code for creating a zone equal that of the Authoritative API `!276 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/276>`__

NEW FEATURES
^^^^^^^^^^^^
- Support Gunicorn config overrides `!277 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/277>`__

IMPROVEMENTS
^^^^^^^^^^^^
- Remove the DNSSEC dialog flicker when opening a zone for the second (or more) time; this also removes a lot of errors on the dev console `!287 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/287>`__
- Fix several build issues making them less flaky and faster `!289 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/289>`__, `!282 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/282>`__, `!281 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/281>`__
- Adapt PDNS Auth API tests for ZoneControl, adding a new test suite `!280 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/280>`__
- Add documentation for zone templates `!292 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/292>`__

1.4.2 (May 19, 2023)
--------------------

DEPLOYMENT NOTES
^^^^^^^^^^^^^^^^
``ZONECONTROL_NSEC3PARAM_DEFAULT`` can be changed in ``settings.py``, but it is advised to keep it at the default of ``"1 0 0 -"``.

BUG FIXES
^^^^^^^^^
- Support for PEP 440 compliant version numbers so RPM packages built again `!270 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/270>`__

NEW FEATURES
^^^^^^^^^^^^
- NSEC3 support in DNSSEC settings for zones `!271 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/271>`__

IMPROVEMENTS
^^^^^^^^^^^^
- Added EL9 packages `!275 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/275>`__
- Upload documentation from GitLab CI to docs.powerdns.com `!273 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/273>`__
- Auth API docs are now proxied through ZoneControl `!272 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/272>`__

1.4.1 (September 2, 2022)
-------------------------

BUG FIXES
^^^^^^^^^
- Fix quotes in LUA example record (`!261 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/261>`__).
- App: hide PTR checkbox when auto PTRs are disabled (`!261 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/261>`__).
- Fix crash due to double saving of audit logs (`!261 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/261>`__).
- Fix editing of LUA records (`ZC-156 <https://jira.open-xchange.com/projects/ZC/issues/ZC-156>`__, `!261 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/261>`__).

1.4.0 (March 10, 2022)
----------------------

From this release onwards Debian Buster is no longer supported.

NEW FEATURES
^^^^^^^^^^^^
- Admin option ``ZONECONTROL_SERVERS_READONLY`` (`ZC-147 <https://jira.open-xchange.com/browse/ZC-147>`__, `!259 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/259>`__).
- Allow disabling history. scheduling, comments and auditlog (`ZC-147 <https://jira.open-xchange.com/browse/ZC-147>`__, `!257 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/257>`__).

IMPROVEMENTS
^^^^^^^^^^^^
- Upgrade to a Python 3.9 that we ship (`ZC-150 <https://jira.open-xchange.com/browse/ZC-150>`__, `!258 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/258>`__).

1.3.4 (October 14, 2021)
------------------------
BUG FIXES
^^^^^^^^^
- Take the Server into account when displaying RRSet comments (`ZC-144 <https://jira.open-xchange.com/projects/ZC/issues/ZC-144>`__, `!256 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/256>`__).

1.3.3 (July 09, 2021)
---------------------

NEW FEATURES
^^^^^^^^^^^^
- Implement the `search API <https://doc.powerdns.com/authoritative/http-api/search.html>`__ endpoint with permission checking (`ZC-120 <https://jira.open-xchange.com/browse/ZC-120>`__, `!249 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/249>`__).

BUG FIXES
^^^^^^^^^
- Stop frontend freezing when searching for template zones with many eligable zones (`ZC-130 <https://jira.open-xchange.com/projects/ZC/issues/ZC-130>`__, `!253 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/253>`__).

1.3.2 (March 25, 2021)
----------------------

IMPROVEMENTS
^^^^^^^^^^^^
- Expose that ZoneControl does APIv1 on ``/api``, as some clients use this information (`ZC-117 <https://jira.open-xchange.com/browse/ZC-117>`__, `!247 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/247>`__).

BUG FIXES
^^^^^^^^^
- Adding and editing a root zone (``.``) now works in the ZoneControl frontend (`ZC-118 <https://jira.open-xchange.com/browse/ZC-118>`__, `!248 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/248>`__).
- Fixed a broken shebang in ``/usr/share/zonecontrol/bin/manage.py`` in the Debian packages (`!250 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/250>`__)

1.3.1 (January 21, 2021)
------------------------

NEW FEATURES
^^^^^^^^^^^^
- PostGreSQL support has been added and can be enabled by installing ``zonecontrol-postgresql`` (`!245 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/245>`__)

BUG FIXES
^^^^^^^^^
- Zone names starting with an ``_`` are no longer improperly escaped (`ZC-98 <https://jira.open-xchange.com/browse/ZC-98>`__, `!244 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/244>`__)

IMPROVEMENTS
^^^^^^^^^^^^
- ``zonecontrol-cache`` has been split into a seperate package for Debian, as was the case for EL

1.3.0 (November 26, 2020)
-------------------------
* Alpha 1: September 22, 2020

NEW FEATURES
^^^^^^^^^^^^
- ``zonecontrol-ldap`` package has been added for integration into LDAP/AD environments (`ZC-93 <https://jira.open-xchange.com/browse/ZC-93>`__, `!230 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/230>`__)

BUG FIXES
^^^^^^^^^
- Requests that trigger the creation of an Auditlog no longer fail when the User Agent string is too long (`ZC-88 <https://jira.open-xchange.com/browse/ZC-88>`__, `!228 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/228>`__)
- Ensure the API endpoints return ``Content-Type: application/json`` (`ZC-92 <https://jira.open-xchange.com/browse/ZC-92>`__, `!232 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/232>`__)

IMPROVEMENTS
^^^^^^^^^^^^
- Add OPENPGPKEY help text (`ZC-7 <https://jira.open-xchange.com/browse/ZC-7>`__, `!233 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/233>`__)
- Update the link to the ALIAS record howto (`!233 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/233>`__)
- Audit log now uses X-Forwarded-For header to get the remote IP address when ZoneControl is behind a proxy (`ZC-91 <https://jira.open-xchange.com/browse/ZC-91>`__, `!229 <https://gitlab.open-xchange.com/powerdns/zonecontrol/-/merge_requests/229>`__)
- Remove the proprietary HTTP Redirect record (`!233 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/233>`__)

1.2.0 (June 15, 2020)
----------------------
* Alpha 1: February 26 2020
* Beta 1: March 16 2020
* RC 1: April 22, 2020

NEW FEATURES
^^^^^^^^^^^^
- Implement automatic PTR record creation (`ZC-42 <https://jira.open-xchange.com/browse/ZC-42>`__, `!196 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/196>`__)
- The zones list can be cached in Redis, drastically improving performance of the web-interface when PowerDNS is serving many domains (`!206 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/206>`__)

  - This requires the ``zonecontrol-cache`` service to be running
  - This caching can be controlled by the the ``ZONECONTROL_CACHE_ZONES_*`` settings

- The DNSSEC information is not longer requested by default for the zone-overview, improving performance of the frontend (`!203 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/203>`__)

  - This can be controlled with the ``ZONECONTROL_ZONE_OVERVIEW_DNSSEC`` configuration option

- The 'edited' serial is now displayed in the zone-overview (`ZC-40 <https://jira.open-xchange.com/browse/ZC-40>`__, `!201 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/201>`__)
- New distribution support:

  - RHEL/CentOS/OL 8
  - Debian Buster

BUG FIXES
^^^^^^^^^
- The slave notifications status is hidden for Native zones (`ZC-52 <https://jira.open-xchange.com/browse/ZC-52>`__, `!208 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/208>`__)
- Underscored records no longer appear in the wrong place in the interface (`ZC-5 <https://jira.open-xchange.com/browse/ZC-5>`__, `!207 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requst/207>`__)

  - This also improves the display of rrset with the same owner name

IMPROVEMENTS
^^^^^^^^^^^^
- Permission management has been tightened (`ZC-1 <https://jira.open-xchange.com/browse/ZC-1>`__, `!194 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/194>`__)

  - Users with these permissions and staff status can add users to their groups:

    - auth | group | Can change group
    - auth | user | Can change user

  - The same user can not see groups they don't belong to
  - Staff users with 'Can change user' permissions can no longer
    - See or give staff status
    - See or give superuser status
    - Edit user permissions
  - No one but superuser can now edit
    - User permissions
    - Group permissions
  - Users can only see users from their groups in the user-admin, but
    they can add them to their groups in the group-admin
  - Several fields in the administrative interface have been hidden as a result
  - Zone and server permissions are now enforced for staff-users in the administrative backend (`ZC-14 <https://jira.open-xchange.com/browse/ZC-14>`__, `!216 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/215>`__)

- Several visuals in the frontend have been harmonized and improved (`!215 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/215>`__)
- Django is updated to the latest LTS version, 2.2 (`!204 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/204>`__)
- Javascript components are upgraded. Most importantly, Angular is now at version 7.2 (`!193 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/193>`__)
- Documentation has been updated with all new features and sections on the permissions model

1.1.1 (July 10, 2019)
---------------------

BUG FIXES
^^^^^^^^^
- Don't have an empty result when the per-RRset limits list is longer than 1 (`!199 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/199>`__)

1.1.0 (June 24, 2019)
---------------------
* Alpha 1: internal only
* Alpha 2: internal only
* Alpha 3: May 20 2019
* Beta 1: May 23 2019

BREAKING CHANGES
^^^^^^^^^^^^^^^^
- Support for the PowerDNS Authoritative Server 4.0 has been dropped. (`#146 <https://github.com/PowerDNS/zonecontrol/pull/146>`__)
- pkgs: Depend on the Python 3.6 from EPEL, not on the one from SCL (`!186 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/186>`__)

NEW FEATURES
^^^^^^^^^^^^
- Ability to limit the kinds of zones that are allowed to be created. By
  default, all 3 kinds are allowed. This limit can be set in the
  settings.py file by the system administrator. (`!172 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/172>`__)
- The zone overview is paginated, showing 25 zones per page. (PDNS-37, `!171 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/171>`__)
- The records overview is paginated, showing 200 records per page. (PDNS-37, `!171 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/171>`__)
- PTR records can be automatically generated by appending a '*' after
  the ip address. This feature can be disabled in the settings.py by the
  system administrator. (PDNS-158, PDNS-189, `!174 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/174>`__)
- The zone settings dialog has been extended with buttons to queue
  NOTIFY messages (for master zones) and retrieve the zone (for slave
  zones). The system administrator can disable this feature in
  settings.py. (`!173 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/173>`__)
- The DNSSEC dialog shows what kind of keys will be created once the
  user clicks "Enable DNSSEC". (PDNS-39, `!175 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/175>`__)
- An 'advanced DNSSEC' role permission has been added. Users with this
  permission have a tab in the DNSSEC dialog that allows manipulation of
  all keys. (PDNS-39, `!175 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/175>`__)
- Per-RRSet role-based access control has been added. This feature
  allows roles to be restricted to records of certain names and
  types. By default, all records are allowed when a role has access to a
  zone. (PDNS-165, PDNS-35, `!178 <https://gitlab.open-xchange.com/powerdns/zonecontrol/merge_requests/178>`__)

BUG FIXES
^^^^^^^^^
- Fix alert when attempting to add an internally managed record at the
  apex. (`#169 <https://github.com/PowerDNS/zonecontrol/pull/169>`__)
- Ensure the UI shows 'repeated' zone names. (PDNS-206,
  `#166 <https://github.com/PowerDNS/zonecontrol/pull/166>`__)
- Mark required textareas in
  forms. (`#167 <https://github.com/PowerDNS/zonecontrol/pull/167>`__)

1.0.1 (July 17, 2018)
---------------------

NEW FEATURES
^^^^^^^^^^^^
- Implement rolebased API "pass through" (#128)
- Comments for zone records (#122)
  - Tool to import comments from PowerDNS Authoritative Server
- roles: Granular permissions for zone settings, DNSSEC and version restores (#104)

IMPROVEMENTS
^^^^^^^^^^^^
- pkg: Let yum figure out which mysql lib to pull in (#144)
- pkg: Add MySQL support package for CentOS 7 (#127)
- admin: More user-friendly role admin UI (#104)
- dnssec: When enabling DNSSEC, the configured DNSSEC server defaults are now honored (#105)

BUG FIXES
^^^^^^^^^
- Fix API error when adding or removing zone (#139)
- Catch SOA entries that do not exist (#133)
- backend: Fix 500 error when adding non-template zone (cf0393e)
- builder: Fix missing styling in built packages, debian build fixes (#95)

1.0.0 (September 20, 2017)
--------------------------
First release.

NEW FEATURES
^^^^^^^^^^^^
- Zone version history and restore (#56)
- Zone templates (#63)
- builder: New build system, CentOS 7 and Debian Stretch packages (#70)

IMPROVEMENTS:
- libs: Upgraded to Angular 4.3.6 and Webpack 3.5.5

BUG FIXES:
- dnssec: Correct handling of ksk/zsk keys in UI (#65)
